/*
+----------------------------------------------------------------------+
|                    Class: CTrigger                                   |
|                                                                      |
| Developer:   Eric Gavaldo (XQual)                                    |
| Launcher:	   STAR                                                    |
| Version:     1.2                                                     |
| License:     GPL v2 (https://www.gnu.org/licenses/gpl-2.0.html)      |
+----------------------------------------------------------------------+
*/
package com.xqual.xtrigger.template;

import java.util.Hashtable;
import java.util.Vector;

import com.xqual.xcommon.IConstantsResults;
import com.xqual.xtrigger.CDatabaseConnectionProperties;
import com.xqual.xtrigger.CPropertyChange;
import com.xqual.xtrigger.CTrigger;
import com.xqual.xtrigger.CTriggerStatus;



/**
 * The <code>CTriggerImpl</code> implementation of <code>ITrigger</code> for STAR.
 * @author rball
 */
public class CTriggerImpl extends CTrigger implements IConstantsResults {

	// +==============================================================+
	// | Attributes                                                   |
	// +==============================================================+

	static final String TRACE_HEADER = "{template    }  ";

	// +==============================================================+
	// | Constructors                                                 |
	// +==============================================================+
	public CTriggerImpl(CDatabaseConnectionProperties databaseConnectionProperties) {
		super(TRACE_HEADER);
	}

	// +------------------------------------+
	// | Initialize                         |
	// +------------------------------------+

	@Override
	public CTriggerStatus initialize() {
		System.out.println(TRACE_HEADER + "initialize()");
		return new CTriggerStatus();
	}

	// +------------------------------------+
	// | Requirement events                 |
	// +------------------------------------+

	@Override
	public CTriggerStatus onRequirementsTreeRefreshed() {
		System.out.println(TRACE_HEADER + "onRequirementsTreeRefreshed()");
		return new CTriggerStatus();
	}

	@Override
	public CTriggerStatus onRequirementCreated(int id, String name, String description, short status, short priority, int risk) {
		System.out.println(TRACE_HEADER + "onRequirementCreated()");
		return new CTriggerStatus();
	}

	@Override
	public CTriggerStatus onRequirementUpdated(int id, Vector<CPropertyChange> changeList) {
		System.out.println(TRACE_HEADER + "onRequirementUpdated()");
		return new CTriggerStatus();
	}
	
	@Override
	public CTriggerStatus onRequirementsDeleted(Vector<Integer> ids) {
		System.out.println(TRACE_HEADER + "onRequirementsDeleted()");
		return new CTriggerStatus();
	}

	@Override
	public CTriggerStatus onRequirementsMoved(Vector<Integer> ids, int folderId) {
		System.out.println(TRACE_HEADER + "onRequirementsMoved()");
		return new CTriggerStatus();
	}

	// +------------------------------------+
	// | Test events                        |
	// +------------------------------------+

	@Override
	public CTriggerStatus onTestsTreeRefreshed() {
		System.out.println(TRACE_HEADER + "onTestsTreeRefreshed()");
		return new CTriggerStatus();
	}
	
	@Override
	public CTriggerStatus onTestCreated(int id, String name, short type, short status, short priority) {
		System.out.println(TRACE_HEADER + "onTestCreated()");
		return new CTriggerStatus();
	}

	@Override
	public CTriggerStatus onTestUpdated(int id, Vector<CPropertyChange> changeList) {
		System.out.println(TRACE_HEADER + "onTestUpdated()");
		return new CTriggerStatus();
	}
	
	@Override
	public CTriggerStatus onTestsDeleted(Vector<Integer> ids) {
		System.out.println(TRACE_HEADER + "onTestsDeleted()");
		return new CTriggerStatus();
	}

	@Override
	public CTriggerStatus onTestsMoved(Vector<Integer> ids, int folderId) {
		System.out.println(TRACE_HEADER + "onTestsMoved()");
		return new CTriggerStatus();
	}

	@Override
	public CTriggerStatus onTestcaseCreated(int id, String name, String description, boolean readyForManualRun, boolean readyForAutomatedRun, String procedure) {
		System.out.println(TRACE_HEADER + "onTestcaseCreated()");
		return new CTriggerStatus();
	}

	@Override
	public CTriggerStatus onTestcaseUpdated(int id, Vector<CPropertyChange> changeList) {
		System.out.println(TRACE_HEADER + "onTestcaseUpdated()");
		return new CTriggerStatus();
	}

	@Override
	public CTriggerStatus onTestcasesDeleted(Vector<Integer> ids) {
		System.out.println(TRACE_HEADER + "onTestcasesDeleted()");
		return new CTriggerStatus();
	}

	@Override
	public CTriggerStatus onTestcaseExecuted(int id, short status) {
		System.out.println(TRACE_HEADER + "onTestcaseExecuted()");
		return new CTriggerStatus();
	}

	// +------------------------------------+
	// | Defect events                      |
	// +------------------------------------+

	@Override
	public CTriggerStatus onBugsTreeRefreshed() {
		System.out.println(TRACE_HEADER + "onBugsTreeRefreshed()");
		return new CTriggerStatus();
	}

	@Override
	public CTriggerStatus onBugCreated(int id, String name, String description, String stepToReproduce, short reproducibility,
									   int platform, int os,
									   short status, short severity, short priority,
									   int reporter, Vector<Integer> assigneeIds, Vector<Integer> sutIds,
									   Hashtable<Integer, Integer> customFieldIntegerHashtable,
									   Hashtable<Integer, String> customFieldStringHashtable,
									   Hashtable<Integer, String> customFieldBooleanHashtable,
									   Hashtable<Integer, String> customFieldHtmlHashtable,
									   Hashtable<Integer, String> customFieldStringChoiceHashtable
									   ) {
		System.out.println(TRACE_HEADER + "onBugCreated()");
		return new CTriggerStatus();
	}

	@Override
	public CTriggerStatus onBugUpdated(int id, Vector<CPropertyChange> changeList) {
		System.out.println(TRACE_HEADER + "onBugUpdated()");
		return new CTriggerStatus();
	}

	@Override
	public CTriggerStatus onBugsDeleted(Vector<Integer> ids) {
		System.out.println(TRACE_HEADER + "onBugsDeleted()");
		return new CTriggerStatus();
	}

	@Override
	public CTriggerStatus onBugsMoved(Vector<Integer> ids, int folderId) {
		System.out.println(TRACE_HEADER + "onBugsMoved()");
		return new CTriggerStatus();
	}

	// +------------------------------------+
	// | Terminate                          |
	// +------------------------------------+
	
	@Override
	public CTriggerStatus terminate() {
		System.out.println(TRACE_HEADER + "terminate()");
		return new CTriggerStatus();
	}
}
